/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.BreastGYNMammoSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_TherapiesForBreast;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_TherapiesForBreast;


/**
 * This class represents TherapiesForBreast - CID6085
 */
public class TherapiesForBreast_CID6085 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new TherapiesForBreast_CID6085 Template 
	 */
	public TherapiesForBreast_CID6085()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumTherapiesForBreast Object of EnumCM_TherapiesForBreast represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_TherapiesForBreast enumTherapiesForBreast)
	{
		switch(enumTherapiesForBreast)
		{
		case CHEMOTHERAPY: this.strCodeValue = EnumCV_TherapiesForBreast.CHEMOTHERAPY_P0_0058E.getValue();break;
		case RADIATION_THERAPY: this.strCodeValue = EnumCV_TherapiesForBreast.RADIATION_THERAPY_P5_C0000.getValue();break;
		case HORMONE_THERAPY: this.strCodeValue = EnumCV_TherapiesForBreast.HORMONE_THERAPY_P0_007AC.getValue();break;
		case BONE_MARROW_TRANSPLANT: this.strCodeValue = EnumCV_TherapiesForBreast.BONE_MARROW_TRANSPLANT_P1_67D40.getValue();break;
		}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumTherapiesforBreast Object of EnumCM_TherapiesforBreast represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_TherapiesForBreast enumTherapiesForBreast)
	{
		switch(enumTherapiesForBreast)
		{
		case CHEMOTHERAPY : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.CHEMOTHERAPY.getSNOMEDCTID(); break;
		case RADIATION_THERAPY : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.RADIATION_THERAPY.getSNOMEDCTID(); break;
		case HORMONE_THERAPY : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.HORMONE_THERAPY.getSNOMEDCTID(); break;
		case BONE_MARROW_TRANSPLANT : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.BONE_MARROW_TRANSPLANT.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for TherapiesForBreast
	 * @param enumTherapiesForBreast Object of EnumCM_TherapiesForBreast.
	 */
	public void setTherapiesForBreast(EnumCM_TherapiesForBreast enumTherapiesForBreast)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumTherapiesForBreast.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumTherapiesForBreast);
		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumTherapiesForBreast);
	}
}
